﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Apache.NMS.ActiveMQ;
using Apache.NMS;
using System.Diagnostics;

namespace ActiveMQ_Test
{
    class Program
    {
        private const string URI = "failover:(tcp://localhost:61616)";
        private const string DESTINATION = "test.queue";
        static ActiveMQClient client;

        static void Main(string[] args)
        {
            Console.WriteLine("Creating and starting the client...");
            client = new ActiveMQClient(URI, DESTINATION);
            Console.WriteLine("Client started! Press CTRL+C to exit.");
            Console.WriteLine();

            Console.CancelKeyPress += new ConsoleCancelEventHandler(Console_CancelKeyPress);

            var sw = new Stopwatch();

            while (true)
            {
                Console.Write("Send Message: ");
                string messageText = Console.ReadLine();
                try
                {
                    sw.Restart();
                    var responseMessage = client.SendMessage(client.CreateTextMessage(messageText));
                    sw.Stop();
                    var responseTextMessage = responseMessage as ITextMessage;
                    if (responseTextMessage == null)
                        Console.WriteLine("=> Received response message, but it wasn't an ITextMessage.");
                    else
                        Console.WriteLine("=> Response [{0}ms]: \"{1}\"", sw.ElapsedMilliseconds, responseTextMessage.Text);
                }
                catch (TimeoutException)
                {
                    Console.WriteLine("=> Timeout!");
                }
                Console.WriteLine();
            }
        }

        static void Console_CancelKeyPress(object sender, ConsoleCancelEventArgs e)
        {
            client.Stop();
            Environment.Exit(0);
        }
    }
}
